import numpy as np
import time
from scipy.special import erf


PROFILER_SCAN = True
HORIZONTAL = False

OLD_TIMING = True

noise = 5

START = time.time()
bgr = 1
event = 0
event2 = 0

offset = 0.

FLOAT1 = 57.5
FLOAT = FLOAT1 + offset
POS = 0
POS1 = POS

POS_H = 0
POS_H1 = POS_H
POS_V = 0
POS_V1 = POS_V

POS2 = POS + 10000
POS2_H = POS_H + 10000
POS2_V = POS_V + 10000
OFFSET = -3
TIMING = 0
TIMING_RB = 0
TIMING_REAL = TIMING + OFFSET
TIMING_RB_old = TIMING

MEAN_H, SIG_H = 1.1, 1.2
MEAN_V, SIG_V = 0.2, 0.8

N = 0
#img = 100+noise*np.random.randn(2000, 2000)
def f(t, t0, offset, amp, tau, sigma):
    return offset -amp/2*np.exp(-((t-t0)-sigma**2/2/tau)/tau)*(1+erf(((t-t0)-sigma**2/tau)/np.sqrt(2)/sigma))

def decay_model(delay, delay_offset, offset, amplitude, tau, sigma):
    return (offset - amplitude / 2 * np.exp(-((delay - delay_offset) - sigma ** 2 / 2 / tau) / tau) *
            (1 + erf(((delay - delay_offset) - sigma ** 2 / tau) / np.sqrt(2) / sigma)))

ii, jj = 100, 200
r = (FLOAT1 - 55) * 40
s1, s2 = 50, r

img_0 = np.zeros([ii, jj])
for i in range(ii):
    for j in range(jj):
        img_0[i, j] += ((10.25 * bgr * 20 * np.exp(-(i - s1) ** 2 / 2 / (4) ** 2 - (j - s2 - 0 * i) ** 2 / 2 / (
                      (0.8 + 2 * abs(s2 - 100) ** 2 / 180 ** 2)) ** 2)) * 0.25 + 0 * j / 5)


S = 0

# knife edge image generation
mean = MEAN_H, MEAN_V  # in mm
sig = SIG_H, SIG_V  # in mm
sizes = 1000, 1000  # 10mm -> 1px = 0.01mm, 1mm == 100px

pos = 500 + mean[0]*100, 500 + mean[1]*100
width = sig[0]*100, sig[1]*100

image = np.zeros([*sizes]).T
for x in range(image.shape[1]):
    for y in range(image.shape[0]):
        image[y, x] += 10 * np.exp(-(y-pos[1])**2/2/width[1]**2 ) * np.exp( -(x-pos[0])**2/2/width[0]**2 )

##################################




def get(address, meta_event=None):
    global image, MEAN_H, SIG_H, MEAN_V, SIG_V, HORIZONTAL, POS2_H, POS2_V, PROFILER_SCAN, start, start2, img_old, bgr, event, event2, noise, FLOAT1, TIMING_ENCODER_OLD, TIMING_ENCODER,  data_old, TIMING_REAL, N, img, S, TIMING_RB, TIMING_RB_old, POS, POS1, POS2
    r = (FLOAT1 - 55)*40
    if address == "TTF2.FEL/HASVUVPGFW3.CAM/PIXIS/IMAGE_EXT_ZMQ":
        ii, jj = 100, 200
        r = (FLOAT1 - 55) * 40
        s1, s2 = 50, r
        s3 = (POS1-0.1)*200
        #img = 100+noise*np.random.randn(3000, 2000)
        #img = pydoocs.read("TTF2.FEL/ICCD8.CAMERA/PCO.CAM1/IMAGE_EXT")['data']
        #ii, jj = 20, 500 #int(pydoocs.read("TEST.DOOCS/UNIT_TEST_SUPPORT/PY_DOOCS/FLOAT1")['data']), 500
        img = 100 + 1*noise * np.random.randn(ii, jj)

        for i in range(ii):
            for j in range(jj):
                img[i, j] += ((10.25*bgr*20 * np.exp(-(i - s1) ** 2 / 2/(4) ** 2 - (j - s2 -0*i) ** 2 /2/ ((0.8+2*abs(s3 + s2-100)**2/180**2)) ** 2) )* 0.25 +0*j/5)
                #img[i, j] += (5.25*bgr*20 * np.exp(-(i - s1) ** 2 / 2/(10) ** 2 - (j - s2 -0.5*i) ** 2 /2/ ((1+2*abs(s2-50)**2/180**2)) ** 2) )

        # for i in range(ii):
        #     for j in range(jj):
        #         img[i, j] += 100*np.exp(-(i - s1 -40) ** 2 / 2/(10) ** 2 - (j - s2-0.5*i +60)**2/2/3**2)
        #         #img[i, j] += 10*np.exp(-(i - s1 -40) ** 2 / 2/(2) ** 2 - (j - s2 +10)**2/2/3**2)

        # for i in range(ii):
        #     for j in range(jj):s
        #         img[i, j] += 500*np.exp(-(i - s1+40-s2) ** 2 / 2/(4) ** 2 - (j -s2)**2/2/4)


        # for i in range(ii):
        #     for j in range(jj):
        #         img[i, j] += 100.00 if abs(i-40) <= 30 and abs(j -20 -i ) <= 5 else 0



                #img[i, j] += (5.25*bgr*20 * np.exp(-(i - s1) ** 2 / 2/(10) ** 2 - (j - s2 -0.5*i) ** 2 /2/ ((1+2*abs(s2-50)**2/180**2)) ** 2) )

        # scale=0.95
        # img[:,0] = 111*scale
        # img[:,1] = 112*scale
        # img[:,2] = 110*scale
        # img[:,2] = 105*scale

        #img = img_0 + offset + 0.5*noise * np.random.randn(ii, jj)

        # if event>= 20:
        #     img = img[:100,:100]

        type = "IMAGE"

        if event != 0 and time.time() - start < .01:
            return Readout({'data': img_old, "miscellaneous": {"event": event}, "macropulse":event, "type":  type}, meta_event)
        else:
            start = time.time()
            img_old = img
            event += 1
            return Readout({'data': img, "miscellaneous": {"event": event}, "macropulse": event, "type": type}, meta_event)
    elif address == "TTF2.FEL/HASY.MONOCHR/MONOCHR/ENERGY":
        noise2 = 0.1
        d = FLOAT + noise2*np.random.randn()
        return Readout({'data': d, "miscellaneous": {"event": 0}, "macropulse": 0, "type": "foo"}, meta_event)
    elif address == "TTF2.FEL/HASY.MONOCHR/MONOCHR/ENERGYTOSET":
        d = FLOAT1
        return Readout({'data': d, "miscellaneous": {"event": 0}, "macropulse": 0, "type": "foo"}, meta_event)
    elif address == "FLASH.SYNC/LASER.LOCK.EXP/F1.PG.OSC/FMC0.MD22.1.POSITION_SET.WR":
        return Readout({'data': TIMING, "type": "foo", "miscellaneous": {"event": event}, "macropulse": 0, "time": time.time()})
    elif address == "FLASH.SYNC/LASER.LOCK.EXP/F1.PG.OSC/FMC0.MD22.1.POSITION.RD":
        TIMING_RB = TIMING_RB_old
        S += 1
        if S % 2 == 0:
            TIMING_RB = TIMING
            TIMING_RB_old = TIMING_RB
        return Readout({'data': TIMING_RB, "type": "foo", "miscellaneous": {"event": event}, "macropulse": 0}, meta_event)


        # if event != 0 and time.time() - start < 0.01:
        #     return Readout({'data':  TIMING_RB_old, "miscellaneous": {"event": event}, "macropulse": 0}, meta_event)
        # else:
        #     start = time.time()
        #     TIMING_RB_old = TIMING
        #     event += 1
        #     S += 1
        #     if True:#S % 10 == 0:
        #         TIMING_RB = TIMING
        #     return Readout({'data':  TIMING, "miscellaneous": {"event": event}, "macropulse": 0}, meta_event)
        # #return Readout({'data': TIMING_RB, "miscellaneous": {"event": event}, "macropulse": 0, "time": time.time()})
    elif address == "FLASH.SYNC/LASER.LOCK.EXP/F1.PG.OSC/FMC0.MD22.1.ENCODER_POSITION.RD":
        #return Readout({'data': TIMING, "miscellaneous": {"event": event}, "macropulse": 0, "time": time.time()})
        return Readout({'data': TIMING_REAL + 0.02 *np.random.randn(), "type": "foo", "miscellaneous": {"event": event}, "macropulse": 0, "time": time.time()})
    elif address == 'FLASH.FEL/ADC.SIS.PG/EXP1.CH06/CH00.TD':
        if not PROFILER_SCAN:
            if OLD_TIMING:
                # #data = (TIMING_REAL + 0.02   *np.random.randn())**2
                # #data = event2/3 + 0.01   *np.random.randn()
                #
                # if TIMING_REAL>3:
                #     data = 0.5 + 0.1  *np.random.randn()
                # else:
                #     data = 0.7 + 0.1 * np.random.randn()
                #
                # if event2 != 0 and time.time() - start < .01:
                #     return Readout({'data': data_old, "miscellaneous": {"event": event}, "macropulse": event2, "time": time.time()})
                # else:
                #     start = time.time()
                #     data_old = data
                #     event2 += 1
                #     return Readout({'data': data, "miscellaneous": {"event": event}, "macropulse": event2, "time": time.time()})


                # data = f((TIMING_REAL + 0.1*np.random.randn())*1e3, 0, 1, 0.015, 1000, 160/2.35) + 0.0015*np.random.randn()
                # #data -= 1
                # data *= 100
                #N+=1
                #data = signal[N]
                sim = 100*np.random.randn(30000)
                sim += 30000
                #sim += np.linspace(0,1000, 30000)
                for i in range(800,25000,100):
                    sim[i-20:i+21] += ( (30000*(1+0.001*np.random.randn())) * (1-np.exp(-(i-700)/1000)) )*np.exp(-(np.arange(-20,21)**2)/2/((2+i/25000*2))**2)
                #sim[sim>200]=200
                #sim[sim>190] += 10*np.random.randn(len(sim[sim>190]))
                    if i % 200 == 0:
                        w = int(5+ i/25000*4)
                        #print(w)
                        #w=10
                        sim[i - w:i + w + 1] *= (1 - (1-decay_model(TIMING_REAL, 5, 1, 0.01, 15, 0.1))*0.1)

                sim = np.round(sim,2)
                #sim[800:25000:200] = sim[800:25000:200]*decay_model(TIMING_REAL, 5, 1, 0.01, 15, 0.1)
                #sim[950:] = 30000+100*np.random.randn(len(sim[950:]))
                #sim[:] = 0
                data = sim
                #data = np.stack((data, data), axis=1)
            else:
                sim = 100 * np.random.randn(30000)
                sim += 30000
                # sim += np.linspace(0,1000, 30000)
                for i in range(800, 25000, 100):
                    sim[i - 20:i + 21] += ((30000 * (1 + 0.001 * np.random.randn())) * (
                                1 - np.exp(-(i - 700) / 1000))) * np.exp(
                        -(np.arange(-20, 21) ** 2) / 2 / ((2 + i / 25000 * 2)) ** 2)

                    if event2 % 2 == 0:
                        if i % 100 == 0:
                            w = int(5 + i / 25000 * 4)
                            # print(w)
                            # w=10
                            sim[i - w:i + w + 1] *= (1 - (1 - decay_model(TIMING_REAL, 5, 1, 0.01, 15, 0.1)) * .1)

                sim = np.round(sim, 2)
                # sim[800:25000:200] = sim[800:25000:200]*decay_model(TIMING_REAL, 5, 1, 0.01, 15, 0.1)
                # sim[950:] = 30000+100*np.random.randn(len(sim[950:]))
                # sim[:] = 0
                data = sim

            if event2 != 0 and time.time() - start2 < .0005:
                return Readout({'data': data_old, "type": "foo", "miscellaneous": {"event": event}, "macropulse": event2, "time": time.time()})
            else:
                #time.sleep(0.1)
                start2 = time.time()
                data_old = data
                event2 += 1 #+ np.random.randint(5)
                return Readout({'data': data, "type": "foo", "miscellaneous": {"event": event}, "macropulse": event2, "time": time.time()})


    if address == "FLASH.DIAG/TOROID.ML/3GUN/NUMBEROFBUNCHES.FLASH1":
        n = 15 #+ np.random.randint(-5,5)
        return Readout({'data': n, "type": "foo", "miscellaneous": {"event": 0}, "macropulse": event2, "time": time.time()})

    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR7.MOT1/FPOS":
        noise2 = 0.01
        d = POS + noise2 * np.random.randn()
        return Readout({'data': d, "type": "foo", "miscellaneous": {"event": 0}, "macropulse": 0}, meta_event)
    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR7.MOT1/FPOS.SET":
        d = POS1
        return Readout({'data': d, "type": "foo", "miscellaneous": {"event": 0}, "macropulse": 0}, meta_event)
    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR7.MOT1/POS.SET":
        S += 1
        if S % 10 == 0:
            POS2 += 1 + 0.1*POS1
        d = POS2
        return Readout({'data': d, "type": "foo", "miscellaneous": {"event": 0}, "macropulse": 0}, meta_event)

    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR8.MOT1/FPOS":
        noise2 = 0.01
        d = POS_H + noise2 * np.random.randn()
        return Readout({'data': d, "type": "foo", "miscellaneous": {"event": 0}, "macropulse": 0}, meta_event)
    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR8.MOT1/FPOS.SET":
        d = POS_H1
        return Readout({'data': d, "type": "foo", "miscellaneous": {"event": 0}, "macropulse": 0}, meta_event)
    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR8.MOT1/POS.SET":
        S += 1
        if S % 10 == 0:
            POS2_H += 1 + 0.1 * POS_H1
        d = POS2_H
        return Readout({'data': d, "type": "foo", "miscellaneous": {"event": 0}, "macropulse": 0}, meta_event)
    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR6.MOT1/FPOS":
        noise2 = 0.01
        d = POS_V + noise2 * np.random.randn()
        return Readout({'data': d, "type": "foo", "miscellaneous": {"event": 0}, "macropulse": 0}, meta_event)
    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR6.MOT1/FPOS.SET":
        d = POS_V1
        return Readout({'data': d, "type": "foo", "miscellaneous": {"event": 0}, "macropulse": 0}, meta_event)
    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR6.MOT1/POS.SET":
        S += 1
        if S % 10 == 0:
            POS2_V += 1 + 0.1 * POS_V1
        d = POS2_V
        return Readout({'data': d, "type": "foo", "miscellaneous": {"event": 0}, "macropulse": 0}, meta_event)
    if address == 'FLASH.FEL/ADC.SIS.PG/EXP1.CH06/CH00.TD':

        if HORIZONTAL:
            scale = get_scale(POS_H1, 0)
        else:
            scale = get_scale(POS_V1, 1)


        sim = 100 * np.random.randn(30000)
        sim += 30000
        for i in range(800, 25000, 100):
            sim[i - 20:i + 21] += scale*((30000 * (1 + 0.001 * np.random.randn())) * (
                        1 - np.exp(-(i - 700) / 1000))) * np.exp(
                -(np.arange(-20, 21) ** 2) / 2 / ((2 + i / 25000 * 2)) ** 2)

        sim = np.round(sim, 2)
        data = sim
        if event2 != 0 and time.time() - start2 < .01:
            return Readout({'data': data_old, "type": "foo", "miscellaneous": {"event": event}, "macropulse": event2,
                            "time": time.time()})
        else:
            # time.sleep(0.1)
            start2 = time.time()
            data_old = data
            event2 += 1  # + np.random.randint(5)
            return Readout({'data': data, "type": "foo", "miscellaneous": {"event": event}, "macropulse": event2,
                            "time": time.time()})


def get_scale(posi, dim):
    global image
    pos = int(500 + posi * 100)
    if pos < 1:
        pos = 1

    image_new = image.copy()
    if dim == 0:
        image_new[:, :pos] = 0
    else:
        image_new[:pos, :] = 0
    return image_new.sum() / image.sum()


def set(address, data):
    global offset, FLOAT, FLOAT1, TIMING, OFFSET, TIMING_REAL,N, POS, POS1, POS_H, POS_H1, POS_V, POS_V1
    if address == "TTF2.FEL/HASY.MONOCHR/MONOCHR/ENERGYTOSET":
        FLOAT1 = data
        FLOAT = data+offset
    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR7.MOT1/FPOS.SET":
        POS1 = data
        #POS = data
    if address == "FLASH.SYNC/LASER.LOCK.EXP/F1.PG.OSC/FMC0.MD22.1.POSITION_SET.WR":
        TIMING = data
        TIMING_REAL = data + OFFSET
        # if N==len(delay)-1:
        #     N=0
        # TIMING_REAL = delay[N]#data + OFFSET
        # N+=1
    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR7.MOT1/CMD":
        if data == 1:
            POS = POS1

    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR8.MOT1/FPOS.SET":
        POS_H1 = data
    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR8.MOT1/CMD":
        if data == 1:
            POS_H = POS_H1
    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR6.MOT1/FPOS.SET":
        POS_V1 = data
    if address == "FLASH.FEL/PG1.TRIXS.MOTOR/MOTOR6.MOT1/CMD":
        if data == 1:
            POS_V = POS_V1

class Readout:
    def __init__(self, pydoocs_output, meta_event=None):
        self._data = pydoocs_output["data"]
        if meta_event:
            self._event = pydoocs_output["miscellaneous"][meta_event]
        else:
            self._event = pydoocs_output["macropulse"]
        self._meta = pydoocs_output["miscellaneous"]
        self._type = pydoocs_output["type"]

    @property
    def data(self):
        return self._data

    @property
    def event(self):
        return self._event

    @property
    def meta(self):
        return self._meta

    @property
    def type(self):
        return self._type
